diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 1a4dc6ad3..a060c5995 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -14,7 +14,6 @@ import java.util.*;
 
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
-import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import it.unimi.dsi.fastutil.objects.Object2LongLinkedOpenHashMap;
 import it.unimi.dsi.fastutil.objects.Object2LongMap;
 import net.minecraft.client.console.LogMessageReceiver;
@@ -28,7 +27,6 @@ import net.minecraft.client.gui.chat.ScreenChat;
 import net.minecraft.client.gui.chat.ScreenSleepMP;
 import net.minecraft.client.gui.error.ScreenBadJavaArch;
 import net.minecraft.client.gui.error.ScreenConflictWarning;
-import net.minecraft.client.gui.error.ScreenMissingJCE;
 import net.minecraft.client.gui.error.ScreenMissingMinecraft;
 import net.minecraft.client.gui.error.ScreenOutOfMemory;
 import net.minecraft.client.gui.options.data.OptionsPages;
@@ -80,14 +78,14 @@ import net.minecraft.core.net.command.commands.CommandTestFor;
 import net.minecraft.core.net.command.commands.CommandTime;
 import net.minecraft.core.net.command.commands.CommandWeather;
 import net.minecraft.core.net.command.util.CommandHelper;
-import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.pool.ObjectPool;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.LoggedPrintStream;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypeGroups;
 
-import javax.crypto.Cipher;
 import javax.imageio.ImageIO;
 import javax.swing.JLabel;
 import javax.swing.JOptionPane;
@@ -182,7 +180,6 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Time;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.PortalHandler;
 import net.minecraft.core.world.World;
@@ -672,6 +669,9 @@ public class Minecraft
             rpcThread.start();
         }
 
+        // Game has started - free any pooled objects that were created during startup
+        ObjectPool.freeAllPools();
+
         gameStarted = true;
 
         boolean hasBeta173 = true;
@@ -1014,9 +1014,7 @@ public class Minecraft
                 	
 					long tickStartTime = System.currentTimeMillis();
                     Time.tick();
-                    AABB.initializePool();
-                    Vec3.initializePool();
-                    NamespaceID.initializePool();
+                    ObjectPool.resetAllPools();
 
                     if(gameWindow.shouldClose()) shutdown();
                     if(isGamePaused && currentWorld != null && !(currentScreen instanceof ScreenModelViewer))
@@ -1122,6 +1120,50 @@ public class Minecraft
                     sndManager.setMuted(gameSettings.muteOnLostFocus.value && !gameWindow.isFocused());
                     guiToasts.render(timer.partialTicks);
 
+                    switch (downloadResourcesThread.downloading) {
+                        case DOWNLOADING: {
+                            double b = java.lang.Math.sin((System.currentTimeMillis() / 1000.0) * 4);
+                            b = b * 0.2 + 0.8;
+                            int ib = (int) java.lang.Math.round(b * 255);
+                            int color = 0xFF000000 | (ib << 16) | (ib << 8) | (ib);
+
+                            int barColor = Color.doubleToIntARGB(1, 0.5 * b, 1.0 * b, 0.5 * b);
+
+                            int sWidth = font.stringWidth(I18n.getInstance().translateKey("gui.main_menu.label.downloading_resources.2"));
+
+                            double progress = (double) downloadResourcesThread.downloadProgress.get() / downloadResourcesThread.toDownload;
+
+                            int minX = (resolution.getScaledWidthScreenCoords() - sWidth) / 2;
+                            int maxX = (resolution.getScaledWidthScreenCoords() + sWidth) / 2 + 1;
+
+                            guiToasts.drawRect(minX - 1, 6, maxX + 1, 38, 0xA0000000);
+                            guiToasts.drawStringCenteredShadow(
+                                font, I18n.getInstance().translateKey("gui.main_menu.label.downloading_resources.1"),
+                                resolution.getScaledWidthScreenCoords() / 2, 7, color);
+                            guiToasts.drawRectDouble(minX, 16, minX + sWidth * progress, 28, barColor);
+                            guiToasts.drawBox(minX, 16, maxX, 28, color, 1);
+                            guiToasts.drawStringCenteredShadow(font, String.format("%d / %d", downloadResourcesThread.downloadProgress.get(), downloadResourcesThread.toDownload), resolution.getScaledWidthScreenCoords() / 2, 18, color);
+                            guiToasts.drawStringCenteredShadow(font, I18n.getInstance().translateKey("gui.main_menu.label.downloading_resources.2"), resolution.getScaledWidthScreenCoords() / 2, 29, color);
+                            break;
+                        }
+                        case ERROR: {
+                            long timePassedSinceError = System.currentTimeMillis() - downloadResourcesThread.timeOfError;
+                            if (timePassedSinceError >= 35 * 1000) {
+                                break;
+                            }
+                            int sWidth = font.stringWidth(I18n.getInstance().translateKey("gui.main_menu.label.downloading_resources.connection.error"));
+
+                            int minX = (resolution.getScaledWidthScreenCoords() - sWidth) / 2;
+                            int maxX = (resolution.getScaledWidthScreenCoords() + sWidth) / 2;
+
+                            guiToasts.drawRect(minX - 2, 5, maxX + 2, 17, 0xA0000000);
+                            guiToasts.drawStringCenteredShadow(
+                                font, I18n.getInstance().translateKey("gui.main_menu.label.downloading_resources.connection.error"),
+                                resolution.getScaledWidthScreenCoords() / 2, 7, 0xFFFF0000);
+                            break;
+                        }
+                    }
+
                     Debug.change("post");  // 3
                     renderer.endRenderGame(timer.partialTicks);
                     
@@ -1214,9 +1256,7 @@ public class Minecraft
         try
         {
             System.gc();
-            AABB.deinitializePool();
-            Vec3.deinitializePool();
-            NamespaceID.deinitializePool();
+            ObjectPool.freeAllPools();
         }
         catch(Throwable ignored) { }
         try
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 6fe80bb49..0d00d3633 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -20,6 +20,7 @@ import net.minecraft.client.gui.ScreenMobPicker;
 import net.minecraft.client.gui.container.ScreenTrommel;
 import net.minecraft.client.gui.ScreenWandMobPicker;
 import net.minecraft.client.gui.guidebook.ScreenGuidebook;
+import net.minecraft.client.gui.nbteditor.ScreenNBTEditor;
 import net.minecraft.client.input.PlayerInput;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.core.achievement.Achievement;
@@ -55,8 +56,11 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
+import java.util.function.Function;
+
 public class PlayerLocal extends Player
 {
     private static final Logger LOGGER = LogUtils.getLogger();
@@ -295,6 +299,11 @@ public class PlayerLocal extends Player
         displayContainerScreen(container);
     }
 
+    @Override
+    public void displayNBTEditor(@Nullable CompoundTag tag, @Nullable Function<@NotNull CompoundTag, Void> exitAction) {
+        mc.displayScreen(new ScreenNBTEditor("NBT Viewer", tag, exitAction));
+    }
+
     @Override
     public void displayWorkbenchScreen(int x, int y, int z)
     {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Gui.java b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
index f9d726850..765af2463 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
@@ -23,7 +23,7 @@ public class Gui
         this.zLevel = 0.0F;
     }
 
-    protected void drawLineHorizontal(int minX, int maxX, final int minY, final int argb)
+    public void drawLineHorizontal(int minX, int maxX, final int minY, final int argb)
     {
         if(maxX < minX)
         {
@@ -34,7 +34,7 @@ public class Gui
         drawRect(minX, minY, maxX + 1, minY + 1, argb);
     }
 
-    protected void drawLineHorizontalDouble(double minX, double maxX, final double minY, final int argb)
+    public void drawLineHorizontalDouble(double minX, double maxX, final double minY, final int argb)
     {
         if(maxX < minX)
         {
@@ -45,7 +45,7 @@ public class Gui
         drawRectDouble(minX, minY, maxX + 1, minY + 1, argb);
     }
 
-    protected void drawLineVertical(final int minX, int minY, int maxY, final int argb)
+    public void drawLineVertical(final int minX, int minY, int maxY, final int argb)
     {
         if(maxY < minY)
         {
@@ -56,7 +56,7 @@ public class Gui
         drawRect(minX, minY + 1, minX + 1, maxY, argb);
     }
 
-    protected void drawLineVerticalDouble(final double minX, double minY, double maxY, final int argb)
+    public void drawLineVerticalDouble(final double minX, double minY, double maxY, final int argb)
     {
         if(maxY < minY)
         {
@@ -99,7 +99,7 @@ public class Gui
         GL11.glEnable(GL_TEXTURE_2D);
         GL11.glDisable(GL_BLEND);
     }
-    protected void drawRectDouble(double minX, double minY, double maxX, double maxY, final int argb)
+    public void drawRectDouble(double minX, double minY, double maxX, double maxY, final int argb)
     {
         if(minX < maxX)
         {
@@ -132,14 +132,14 @@ public class Gui
         GL11.glDisable(GL_BLEND);
     }
 
-    protected void drawBox(final int minX, final int minY, final int maxX, final int maxY, final int argb, final int lineThickness) {
+    public void drawBox(final int minX, final int minY, final int maxX, final int maxY, final int argb, final int lineThickness) {
         drawRect(minX, minY, maxX, minY + lineThickness, argb);
         drawRect(minX, maxY - lineThickness, maxX, maxY, argb);
         drawRect(minX, minY + lineThickness, minX + lineThickness, maxY - lineThickness, argb);
         drawRect(maxX - lineThickness, minY + lineThickness, maxX, maxY - lineThickness, argb);
     }
 
-    protected void drawRectNoBlend(int minX, int minY, int maxX, int maxY, final int argb)
+    public void drawRectNoBlend(int minX, int minY, int maxX, int maxY, final int argb)
     {
         if(minX < maxX)
         {
@@ -169,7 +169,7 @@ public class Gui
         GL11.glEnable(GL_TEXTURE_2D);
     }
     
-    protected void drawRectWidthHeight(final int x, final int y, final int width, final int height, final int argb) {
+    public void drawRectWidthHeight(final int x, final int y, final int width, final int height, final int argb) {
     	final float a = ((argb >> 24) & 0xFF) / 255f;
     	final float r = ((argb >> 16) & 0xFF) / 255f;
     	final float g = ((argb >>  8) & 0xFF) / 255f;
@@ -186,7 +186,7 @@ public class Gui
         glEnable(GL_TEXTURE_2D);
     }
 
-    protected void drawGradientRect(final int minX, final int minY, final int maxX, final int maxY, final int argb1, final int argb2)
+    public void drawGradientRect(final int minX, final int minY, final int maxX, final int maxY, final int argb1, final int argb2)
     {
         final float a1 = (float)(argb1 >> 24 & 0xff) / 255F;
         final float r1 = (float)(argb1 >> 16 & 0xff) / 255F;
@@ -219,7 +219,7 @@ public class Gui
     public void drawStringCenteredShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
         fontRenderer.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setShadow().setColor(argb).call();
     }
-    
+
     public void drawStringCenteredNoShadow(final @NotNull FontRenderer fontRenderer, final @NotNull CharSequence chars, final int x, final int y, final int argb) {
         fontRenderer.renderCentered(Tessellator.instance, chars, x, y).setZ(this.zLevel).setColor(argb).call();
     }
@@ -523,10 +523,10 @@ public class Gui
         }
     }
 
-    public void drawGuiIcon(final int x, final int y, final int width, final int height, final IconCoordinate coordinate) {
+    public void drawGuiIcon(final int x, final int y, final int width, final int height, final @NotNull IconCoordinate coordinate) {
         drawGuiIconDouble(x, y, width, height, coordinate);
     }
-    public void drawGuiIconDouble(final double x, final double y, final double width, final double height, final IconCoordinate coordinate) {
+    public void drawGuiIconDouble(final double x, final double y, final double width, final double height, final @NotNull IconCoordinate coordinate) {
         coordinate.parentAtlas.bind();
         final Tessellator t = Tessellator.instance;
         if (coordinate.hasMeta("gui")) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Screen.java b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
index 9f7b550a4..a107205bf 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
@@ -79,9 +79,11 @@ public abstract class Screen extends Gui {
     public void mouseClicked(int mx, int my, int buttonNum) {
         if (buttonNum == 0) {
             for (ButtonElement button : buttons) {
-                if (button.mouseClicked(mc, mx, my) && button.playSound) {
+                if (button.mouseClicked(mc, mx, my)) {
                     clickedButton = button;
-                    mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                    if (button.playSound) {
+                        mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                    }
                     if (button.listener != null) {
                         button.listener.listen(button);
                     } else {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
index 75492bed0..42302ef96 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
@@ -14,7 +14,7 @@ import java.util.Map;
 
 public class ScreenFontTest extends Screen{
     private static final char[] chars = {'H', 'e', 'l', 'l', 'o', ' ', 'W', 'o', 'r', 'l', 'd', '!'};
-    private static final @NotNull NamespaceID testId = NamespaceID.getPermanent("test", "value");
+    private static final @NotNull NamespaceID testId = NamespaceID.fromPool("test", "value").copyUnpooled();
     private static final @NotNull StringBuilder builder = new StringBuilder();
     public double scroll = 0;
     public ScreenFontTest(final @Nullable Screen parent) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index fa534ca2c..a32f30efb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -362,18 +362,6 @@ public class ScreenMainMenu extends Screen
         String disclaimer2 = i18n.translateKey("gui.main_menu.label.disclaimer.2");
         drawStringShadow(fontRenderer, disclaimer2, width - MathHelper.ceil(fontRenderer.stringWidthDouble(disclaimer2)) - 2, height - 10, 0xffffff);
         super.render(mx, my, partialTick);
-        
-    	if(mc.downloadResourcesThread.downloading) {
-    		double b = java.lang.Math.sin((System.currentTimeMillis() / 1000.0) * 4);
-    		b = b * 0.2 + 0.8;
-    		int ib = (int) java.lang.Math.round(b * 255);
-    		int color = 0xFF000000 + (ib << 16) + (ib << 8) + (ib);
-
-            drawStringCenteredShadow(
-                mc.font, i18n.translateKeyAndFormat("gui.main_menu.label.downloading_resources.1", mc.downloadResourcesThread.downloadProgress.get(), mc.downloadResourcesThread.toDownload),
-                width / 2, 8, color);
-            drawStringCenteredShadow(mc.font, i18n.translateKey("gui.main_menu.label.downloading_resources.2"), width / 2, 17, color);
-    	}
     }
 
     private void drawLogo(final float partialTick) {
@@ -403,7 +391,7 @@ public class ScreenMainMenu extends Screen
         GL11.glDepthMask(true);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
         Lighting.enableLight(0.5f, 0.16f);
-        
+
         for(int renderPass = 0; renderPass < 3; ++renderPass) {
             GL11.glPushMatrix();
             GL11.glTranslatef(0.4F, 0.6F, -12.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index 3e5d3f2ac..ccfce48e5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -420,7 +420,6 @@ public class ScreenAchievements extends Screen
         }
 
         renderLabels();
-        GL11.glEnable(GL11.GL_LIGHTING);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
 
         hoveredAchievement = null;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 43b57c0dd..3f18e2a5e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -650,18 +650,6 @@ public class HudIngame extends Gui
             tessellator.addVertexWithUV(itemEndX,                            20, 0.0f, 0, 0);
             tessellator.draw();
         }
-
-        if (mc.gameSettings.immersiveMode.drawOverlays() && mc.downloadResourcesThread.downloading) {
-            double b = java.lang.Math.sin((System.currentTimeMillis() / 1000.0) * 4);
-            b = b * 0.2 + 0.8;
-            int ib = (int) java.lang.Math.round(b * 255);
-            int color = 0xFF000000 + (ib << 16) + (ib << 8) + (ib);
-            drawStringCenteredShadow(
-                mc.font,
-                stringtranslate.translateKeyAndFormat("gui.main_menu.label.downloading_resources.1", mc.downloadResourcesThread.downloadProgress.get(), mc.downloadResourcesThread.toDownload),
-                width / 2, 16 + sp, color);
-            drawStringCenteredShadow(mc.font, stringtranslate.translateKey("gui.main_menu.label.downloading_resources.2"), width / 2, 25 + sp, color);
-        }
     }
 
     private int debugLine = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/ScreenNBTEditor.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/ScreenNBTEditor.java
new file mode 100644
index 000000000..d9a477db9
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/ScreenNBTEditor.java
@@ -0,0 +1,149 @@
+package net.minecraft.client.gui.nbteditor;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.nbteditor.components.AbstractTagComponent;
+import net.minecraft.client.gui.nbteditor.components.CompoundTagComponent;
+import net.minecraft.client.render.Scissor;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.GL11;
+import org.slf4j.Logger;
+
+import java.util.ArrayList;
+import java.util.Comparator;
+import java.util.List;
+import java.util.function.Function;
+
+public class ScreenNBTEditor extends Screen {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    public final @Nullable String title;
+    public final @Nullable CompoundTag inputTag;
+    public final @Nullable Function<@NotNull CompoundTag, Void> tagAction;
+
+    private final CompoundTagComponent compoundTagComponent;
+    private double scroll = 0;
+
+    public ScreenNBTEditor(@Nullable String title, @Nullable CompoundTag inputTag, @Nullable Function<@NotNull CompoundTag, Void> exitAction) {
+        this(null, title, inputTag, exitAction);
+    }
+
+    public ScreenNBTEditor(@Nullable Screen parentScreen, @Nullable String title, @Nullable CompoundTag inputTag, @Nullable Function<@NotNull CompoundTag, Void> exitAction) {
+        super(parentScreen);
+        this.title = title;
+        this.inputTag = inputTag;
+        this.tagAction = exitAction;
+
+        this.compoundTagComponent = new CompoundTagComponent(this, new CompoundTag(inputTag));
+        this.compoundTagComponent.expanded = true;
+    }
+
+
+    @Override
+    public void removed() {
+        if (this.tagAction != null) {
+            this.tagAction.apply((CompoundTag) compoundTagComponent.tag);
+        }
+    }
+
+    @Override
+    public void render(int mx, int my, float partialTick) {
+        int compHeight = compoundTagComponent.height(-1, -1, partialTick);
+        int minScroll = 0;
+        int maxScroll = Math.max(compHeight - (height - 84), 0);
+        this.scroll += Mouse.getDWheel() * 10;
+        this.scroll = MathHelper.clamp(this.scroll, -maxScroll, minScroll);
+
+        renderBackground();
+        super.render(mx, my, partialTick);
+
+        Tessellator t = Tessellator.instance;
+
+        {
+            int popupWidth = width/2 + 40;
+            int popupHeight = height - 40;
+            int popupX = width / 2 - popupWidth / 2;
+            int popupY = height / 2 - popupHeight / 2;
+
+            GL11.glDisable(GL11.GL_LIGHTING);
+            GL11.glDisable(GL11.GL_FOG);
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+
+            GL11.glEnable(GL11.GL_TEXTURE_2D);
+            float f = 32F;
+            t.startDrawingQuads();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            t.setColorOpaque_I(0x404040);
+            t.addVertexWithUV(popupX, popupY + popupHeight, 0.0D, 0.0D, (float)popupHeight / f);
+            t.addVertexWithUV(popupX + popupWidth, popupY + popupHeight, 0.0D, (float)popupWidth / f, (float)popupHeight / f);
+            t.addVertexWithUV(popupX + popupWidth, popupY, 0.0D, (float)popupWidth / f, 0);
+            t.addVertexWithUV(popupX, popupY, 0.0D, 0.0D, 0);
+            t.draw();
+
+            drawRect(width/4, 40, (width * 3)/4, height - 40, 0x88000000);
+        }
+
+        fontRenderer.renderCentered(t, title, width/2, 26).setShadow().call();
+
+        if (minScroll != maxScroll) {
+            drawRect((width * 3)/4 - 5, 41, (width * 3)/4 - 1, height - 43, 0xFF000000);
+
+            int scrollableRegion = compHeight;
+            int regionHeight = height - 84;
+            int sMin = (int) scroll;
+
+            int barMinX = (width * 3)/4 - 6;
+            int barMaxX = (width * 3)/4 - 2;
+            int barMinY = (42 - MathHelper.round(((double)sMin/scrollableRegion) * regionHeight));
+            int barMaxY = barMinY + MathHelper.round(((double)regionHeight/scrollableRegion) * regionHeight);
+
+            boolean hovered = mx >= barMinX && mx <= barMaxX && my >= barMinY && my <= barMaxY;
+            drawRect(barMinX, barMinY, barMaxX, barMaxY, hovered ? 0xFFCCCCFF : 0xFFFFFFFF);
+        }
+
+        Scissor.enable(width/4 - 20, 40, width/2 + 13, height - 80);
+        int y = (int) (42 + scroll);
+        boolean inPane =
+            mx >= width/4 - 20 &&
+            mx <=(width * 3)/4 -20 + 13 &&
+            my >= 40 &&
+            my <= height - 40;
+        compoundTagComponent.render(t, width/4 + 2, y, inPane ? mx - width/4 : -1, inPane ? my - y : -1, partialTick);
+        Scissor.disable();
+
+        drawBox(width/4 - 20, 20, (width * 3)/4 + 20, height - 20, 0xFFFFFFFF, 1);
+        drawBox(width/4, 40, (width * 3)/4, height - 40, 0xFFFFFFFF, 1);
+    }
+
+    @Override
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        super.mouseClicked(mx, my, buttonNum);
+
+        int y = (int) (42 + scroll);
+        boolean inPane =
+            mx >= width/4 - 20 &&
+                mx <=(width * 3)/4 -20 + 13 &&
+                my >= 40 &&
+                my <= height - 40;
+        compoundTagComponent.onMouseClick(inPane ? mx - width/4 : -1, inPane ? my - y : -1, buttonNum, 1);
+    }
+
+    @Override
+    public void mouseReleased(int mx, int my, int buttonNum) {
+        super.mouseReleased(mx, my, buttonNum);
+
+        int y = (int) (42 + scroll);
+        boolean inPane =
+            mx >= width/4 - 20 &&
+                mx <=(width * 3)/4 -20 + 13 &&
+                my >= 40 &&
+                my <= height - 40;
+        compoundTagComponent.onMouseRelease(inPane ? mx - width/4 : -1, inPane ? my - y : -1, buttonNum, 1);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/AbstractTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/AbstractTagComponent.java
new file mode 100644
index 000000000..e31a922bf
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/AbstractTagComponent.java
@@ -0,0 +1,85 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.ByteArrayTag;
+import com.mojang.nbt.tags.ByteTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.DoubleArrayTag;
+import com.mojang.nbt.tags.DoubleTag;
+import com.mojang.nbt.tags.FloatTag;
+import com.mojang.nbt.tags.IntTag;
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.LongArrayTag;
+import com.mojang.nbt.tags.LongTag;
+import com.mojang.nbt.tags.ShortArrayTag;
+import com.mojang.nbt.tags.ShortTag;
+import com.mojang.nbt.tags.StringTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
+
+public abstract class AbstractTagComponent<T> extends Gui {
+    public static final int COLOR_BACKGROUND = 0x88A0A0A0;
+    public static final int COLOR_BACKGROUND_HIGHLIGHTED = 0x886060A0;
+    public static final int SHIFT_RIGHT = 13;
+    public static final int COMPONENT_PADDING = 1;
+    public static final int TEXT_PADDING = 2;
+
+    public final @NotNull Screen attachedScreen;
+    public final @NotNull Tag<T> tag;
+    public AbstractTagComponent(@NotNull Screen attachedScreen, @NotNull Tag<T> tag) {
+        this.attachedScreen = attachedScreen;
+        this.tag = tag;
+    }
+
+    public void render(@NotNull Tessellator t, int offX, int offY, int mx, int my, float partialTick) {
+        GL11.glColor4f(1, 1, 1, 1);
+        drawGuiIcon(offX, offY, 12, 12, getIcon(mx, my, partialTick));
+    }
+
+    public int height(int mx, int my, float partialTick) {
+        return 12;
+    }
+    public int width(int mx, int my, float partialTick) {
+        return attachedScreen.width/2;
+    }
+
+    public boolean isHovered(int mx, int my, float partialTick) {
+        int h = height(mx, my, partialTick);
+        int w = width(mx, my, partialTick);
+        return mx >= 0 && mx <= w && my >= 0 && my <= h;
+    }
+
+    public void onMouseClick(int mx, int my, int mouseButton, float partialTick) {
+
+    }
+
+    public void onMouseRelease(int mx, int my, int mouseButton, float partialTick) {
+
+    }
+
+    public abstract @NotNull IconCoordinate getIcon(int mx, int my, float partialTick);
+
+    public static @Nullable AbstractTagComponent componentForTag(@NotNull Screen attachedScreen, @NotNull Tag<?> tag) {
+        switch (Tag.TagID.fromId(tag.getId())) {
+            case TAG_BYTE: return new ByteTagComponent(attachedScreen, (ByteTag) tag);
+            case TAG_SHORT: return new ShortTagComponent(attachedScreen, (ShortTag) tag);
+            case TAG_INT: return new IntTagComponent(attachedScreen, (IntTag) tag);
+            case TAG_LONG: return new LongTagComponent(attachedScreen, (LongTag) tag);
+            case TAG_FLOAT: return new FloatTagComponent(attachedScreen, (FloatTag) tag);
+            case TAG_DOUBLE: return new DoubleTagComponent(attachedScreen, (DoubleTag) tag);
+            case TAG_BYTE_ARRAY: return new ByteArrayTagComponent(attachedScreen, (ByteArrayTag) tag);
+            case TAG_STRING: return new StringTagComponent(attachedScreen, (StringTag) tag);
+            case TAG_LIST: return new ListTagComponent(attachedScreen, (ListTag) tag);
+            case TAG_COMPOUND: return new CompoundTagComponent(attachedScreen, (CompoundTag) tag);
+            case TAG_SHORT_ARRAY: return new ShortArrayTagComponent(attachedScreen, (ShortArrayTag) tag);
+            case TAG_DOUBLE_ARRAY: return new DoubleArrayTagComponent(attachedScreen, (DoubleArrayTag) tag);
+            case TAG_LONG_ARRAY: return new LongArrayTagComponent(attachedScreen, (LongArrayTag) tag);
+            default: return null;
+        }
+    }
+}
